// -*-C++-*-


// ---------- AlgoStatusClass -------------

class AlgoStatusClass{

public:
  int type;   /// type of algorithm
  //  BOOL online; /// online or not problem
  INDEX noNodes;
  GraphClass *graphInfo; // Ptr to the graph where the algo will execute
  INDEX *Father;
  STREAM *ExistStream;
  BOOL *Status;
  INDEX *JoinToNode; // best node to join so far
  STREAM *JoinStream; // best stream to join with JoinToNode 
  HAP    *JoinHapCost; // best HapCost value so far
  COST *JoinCost;
  Session  *sessionPtr;

AlgoStatusClass( GraphClass *givenGraphInfo);

~AlgoStatusClass(); 

//   void setOnline(BOOL stat){
//     if (stat != YES || stat!=NO)
//       error("Algo::setOnline(): assigning value: " << stat <<NL );
//     online = stat;
//   };

// BOOL isOnline(){
//     return online;
//   };

void setSession(Session *sessPtr) {
    sessionPtr = sessPtr;
  }

Session * getCurrentSession() {
    return sessionPtr;
  }

BOOL isVisit(INDEX node) { 
  if (Status[node] == VISIT_MST)
    return YES;
  else return NO;
};

void putInTree(INDEX node) {
    if (Status[node] != REACHED)
      setStatus(node, IN_TREE);
 };

BOOL isInTree(INDEX node) {
  int status;
  status = Status[node];
  if ((status == IN_TREE) || (status == REACHED))
    return YES;
  else return NO;
};

  // Lazy version HAS TO BE CHANGED to the one below
  //  BOOL isReached(INDEX node) { return isInTree(node);}
BOOL isReached(INDEX node) {
  if (Status[node] == REACHED)
   return YES;
  else return NO;
  
};
void setType(int algoType) { type = algoType; };
int getType() { return type; };
void setStatus(INDEX n, BOOL stat ){ Status[n] = stat; };
BOOL getStatus(INDEX n, BOOL stat ){ return Status[n]; };
INDEX getNoNodes(){ return noNodes; };
void setFather(INDEX n, INDEX fath) { Father[n] = fath; };
void setExistStream(INDEX n, STREAM str) { ExistStream[n] = str; };
Edge **getGraph(){ return graphInfo->getGraph(); };
GraphClass *getGraphInfo(){ return graphInfo; };
STREAM *getExistStreamArr() { return ExistStream; };
STREAM getExistStream(INDEX node) { return ExistStream[node]; };
INDEX *getFatherArr() { return Father; }; 
INDEX getFather(INDEX node) { return Father[node]; }; 
PathClass *getPath(INDEX n1, INDEX n2) {
    return graphInfo->getPathPtr(n1, n2);
  };
void setJoinHapCost(INDEX node, HAP hapCost) {
    JoinHapCost[node] = hapCost; 
};
void setJoinToNode(INDEX node, INDEX toNode) {
    JoinToNode[node] = toNode;
 };
void setJoinStream(INDEX node, STREAM str) {
    JoinStream[node] = str; 
 };
void setJoinCost(INDEX node, COST cost) {
    JoinCost[node] = cost; };
COST getJoinCost(INDEX node) {
    return JoinCost[node]; };
HAP getJoinHapCost(INDEX node) {
  return JoinHapCost[node]; };
STREAM  getJoinStream(INDEX node) {
  return JoinStream[node]; };
INDEX getJoinToNode(INDEX node) {
    return JoinToNode[node]; };
INDEX getNextNode();

};  // ---- end of AlgoStatusClass ----------

