#include "header.h"
#include "classes.h"
#include "session.h"

// This file contains all the classes -- 25-4-97 Michalis
//#include "header.h"
//   This file gets included in the header.h -- Stupid though

// ------------    GENERAL PURPOSE FUNCTIONS ------------
BOOL infinitDistance(WEIGHT dist) {
  if (dist == INFINIT_DISTANCE) 
    return YES;
  else return NO;
};
BOOL  minusInfinitCost(COST cost) {
  if (cost == Minus_INFINIT_double) 
    return YES;
  else return NO;
};

// ------------ END OF GENERAL PURPOSE FUNCTIONS ------------
//class setElementSelection {
setElementSelection::setElementSelection(int a, int b) {
    // a, b inclusive integer range from which we choose
    int i;
    int size;

    size = b - a + 1; // [a...b]
    nonChosen = new int[size];
    index = size - 1; // point at the last element
    for( i = 0; i < size; i++) {
      nonChosen[i] = i;
    }
  };

setElementSelection::~setElementSelection(){
  delete nonChosen;
};

int setElementSelection::getNext(){
    int newEl;
    int value;

    // choose an element from the nonChosen ones
    newEl = chooseInt(0, index);
    value = nonChosen[newEl];
    // replace the chosen value with the last one
    nonChosen[newEl] = nonChosen[index];
    index--;
    return value;
}
//};  // end  setElementSelection


   
//   // END OF class Session methods



GraphClass::GraphClass(INDEX noNodes){
    INDEX i,j;
    
  //   graph = givenGraph;
  graph = new (Edge *)[noNodes];
  for(i=0; i < NoNodes; i++) 
    graph[i] = new Edge[noNodes];
  for (i=0; i< NoNodes; i++)
    graph[i][i].setWeight(0);
 


    nodes = noNodes;
    setMaxAsymmetry(MAX_ASYMMETRY);
    ShortPathMat = new (PathClass *)[noNodes];
    for(i=0; i<noNodes; i++) {
      ShortPathMat[i] = new PathClass[noNodes];
    };
  };

void  GraphClass::createEdge( INDEX n1, INDEX n2, WEIGHT w, double asym) {

  //Edge **Mat;
  //Edge *edge;
  double distr_asym;
  double weight1, weight2; // the distinct weights that will be used
  // to assigne the assymetry to the weight of the edges

 getEdge(n1,n2)->setUndirWeight(w);
 getEdge(n2,n1)->setUndirWeight(w);


  if ( asym <= 0) {
    weight1 = w;
    weight2 = NO_EDGE;
    error(" WARNING. createEdge(): asym < 0 for Nodes:" << n1 <<" "<< n2 );
  } else {
    // find a distribution of the asymmetry
    distr_asym = chooseDouble(1, (double)  asym);
    // asym = MAX_ASYMMETRY;
   
    weight1 = (double)  w * distr_asym ;
    weight2 = (double)  w ;
    // weight1 = w * sqrt(distr_asym);
    // weight2 = w / sqrt(distr_asym);
  }

  
  if ( toss() ) { 
   getEdge(n1,n2)->load((WEIGHT) weight1, n1, n2);
   getEdge(n2,n1)->load((WEIGHT) weight2, n2, n1);
  } else {
   getEdge(n1,n2)->load((WEIGHT) weight2, n1, n2);
   getEdge(n2,n1)->load((WEIGHT) weight1, n2, n1);
  };

};



void GraphClass::allShortestPaths() {

  //*********************************************
  //	Method: allShortestPaths()
  //     ADDED: 25/4/96  petros
  //            made as method 26/4/97 michalis
  //*********************************************
  Edge **cdG; // the complete graph of destinations
  int i,j,v,count ;
  INDEX *Father;
  WEIGHT *Label ; // for use in Dijkstra
  INDEX node_whole, node_whole2,  cur_node ;
  WEIGHT totCost ;
  PathClass *tmpPathPtr;
  INDEX N;  // number of nodes
  

  // graph is a  field of  GraphClass\

  tmpPathPtr = new PathClass(nodes); // aux to keep track of nodes
  // Initialize complete distance subgraph graph
  Father = new INDEX[nodes];
  Label = new WEIGHT[nodes];
  cdG = new (Edge *) [nodes] ;
  for( i = 0 ; i < nodes ; i++ )
    cdG[i] = new Edge[nodes] ;
  for( i = 0 ; i < nodes ; i++ )
    cdG[i][i].makeNO_EDGE();
  //------------ Call exisitng function -------------
  //completeSubgraph(graph,  N, sessionPtr,  noPart, scdG);
  debugN2(" completeGraph(): ");
  for( v = 0 ; v < nodes ; v++ )   {
    // shortest path from v to all nodes, initializes Father, Label
    //if (sessionPtr->isPartic(v) == YES) {
      findDJK(graph,nodes,v,Father,Label) ;
      for( i = 0 ; i < nodes ; i++ ) {
	// calculate total cost on path and assign on cdG[v][i]
	//	tmpPath.addNode(i);
	if (infinitDistance(Label[i]) == NO){
	  tmpPathPtr->makeEmpty();
	  cur_node = i ; 
	  totCost = 0 ;
	  // debugN2(" N: " << v << " N: " << i ); // path check
	  while( cur_node != v ) {
	    tmpPathPtr->addNode(cur_node);
	    // For directed case: fath -> node
	    totCost += graph[Father[cur_node]][cur_node].getWeight() ;
	    cur_node = Father[cur_node] ;
	  } // while
	  tmpPathPtr->addNode(v);
	  // debugN2(" END node-source pass "); // path check
	  // Line below: the NodeArr of the path is new-ed in readInversePath()
	  getPathPtr(v,i)->readInversePath(tmpPathPtr);
	  getPathPtr(v,i)->setDistance(totCost);
	
	  // KMB: for the creation of the complete graph
	  cdG[v][i].setWeight(totCost) ;
	} else {
	  getPathPtr(v,i)->makeEmpty();
	  };
      } // for( i )
      //} // if (isPartic(v) == YES) 

  } // for
  //      debugN2(" AllShortestPaths():  Distance Graph :");
  //  printMat(cdG, N);
};


int GraphClass::makeAsymmetry( double asy){
  INDEX node1, node2;
  WEIGHT weight;

  setMaxAsymmetry(asy);
  for(node1 = 0; node1 <  getNoNodes(); node1++) {
    for(node2 = 0; node2 < node1; node2++) {
      //debug4(" GClass::makeAsymmetry(): nodes: "<<node1<<" "<<node2);
      //debugN4(" EDGE: " << getEdge(node1, node2)->isNO_EDGE());
      if (getEdge(node1, node2)->isNO_EDGE() == NO) {
	weight = getEdge(node1, node2)->getUndirWeight();
	//debug4(" GraphClass::makeAsymmetry(): nodes: "<<node1<<" "<<node2);
	//	debugN4(" W: " << weight);
	createEdge( node1, node2, weight, asy);
	}
    }
  }

 // printMat(getGraph(), getNoNodes());
  return EXEC_OK;
}
