# include "header.h"
#include "classes.h"

// Edge *  edgeP(INDEX n1, INDEX n2) {
//   // WHAT: returns the pointer to the golbal Matrix
//   // HAS TO BE CORRECTED : badly designed
//   return (&Matrix[n1][n2]);
// }


// BOOL adjacent(INDEX n1, INDEX n2) {
//   // WHAT: return if two nodes are connected with an edge

//   if ( edgeP(n1,n2)->isNO_EDGE() == YES)
//     return NO;
//   else
//     return YES;
// };

void doNeighDJK(Edge **Mat, INDEX node, INDEX N, int *Status,
  INDEX *Father, WEIGHT *Label) {
  // Function: Finds the new NEIGHboors and updates all NEIGH distances
  //     It changes Status, Label, Father
  int i;
  WEIGHT newDist;

     for (i=0; i<N; i++) {
       //debug("doNeighDJK: adj: " << adjacent_general(Mat,node, i));
       if ((adjacentMat(Mat, node, i) == YES) && (Status[i] != VISIT_MST)) {
	  
	  Status[i] = NEIGH_MST;
	  // For directed case: source -> node -> i
	  newDist =  Label[node]+Mat[node][i].getWeight();
	  if ( compareWeight(Label[i], newDist) == GREAT){
	    Father[i] = node;
	    Label[i] = newDist;
	  } // if compare
	  //debug("doNeighDJK: adjacents " << node << " and  " << i <<" Dist: "<<Label[i]);
	} // if adjacent
      } // for
} // end of doNeighDJK()

INDEX minDistNeighDJK(INDEX N, int *Status, WEIGHT *Label) {
  INDEX minNode = NONE;
  int i;
  WEIGHT minDist;

  minDist = INFINIT_int;
  for (i=0; i<N; i++) {
    if ((Status[i] == NEIGH_MST) && (compareWeight(Label[i], minDist) == LESS)){
      minNode = i;
      minDist = Label[i];   // make sure that this will copy struct
      // if WEIGHT becomes struct.
    }
    //debug("minDistNeighDJK: " << i << "  Dist:  " << Label[i]);
  }
  return minNode;
 }

int findDJK(Edge **Mat, INDEX N, INDEX root, INDEX *Father, WEIGHT *Label){
  // function: Given Adj Mat, Nodes, root, return the Dijkstra tree  
  // (Father) and the Min Distances (Label) -- both are *new* from caller

  INDEX newnode;  // the new node that becomes VISITed
  int *Status;    // Node status: NONE, NEIGH, VISIT_MST
  int i;
  BOOL STOP;
  // ------ Initialization of Matrices ------------
  Status = new int[N];
  for (i=0; i<N; i++) {
    Status[i] = NONE;
    Label[i] = INFINIT_int;
    Father[i] = i;
  }

  //Dist[root] = 0;
  Label[root] = 0;
  doNeighDJK(Mat,root, N, Status,  Father, Label);
  Status[root] = VISIT_MST;
  STOP = NO;
  while (STOP == NO){
    newnode = minDistNeighDJK(N, Status, Label);
    //debug("findMST: newnode: " << newnode);
    if (newnode == NONE)
      STOP = YES;
    else {
      Status[newnode] = VISIT_MST;
      doNeighDJK(Mat, newnode, N, Status,  Father, Label);
    } // else
  } // while

 
  delete []Status;
  return EXEC_OK;

} // function findMST()
