// -*-C++-*-
// the above makes emacs understand that this is  C++ header
/// All variables here should be extern
//  and must be define in only one file *.cc



//#pragma interface

//#include <stream.h>
#include <iostream.h>
#include <fstream.h>
//#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//#include <ctype.h>
#include <math.h>

// Type definition
#define    NODEID  int
#define    WEIGHT   int
#define    EDGE         int
#define    BOOL         int
#define    INDEX    int     // the number id of the nodes
#define TOKEN             int
#define  PROB      float
#define   HAP  double
#define    STREAM  int
#define   BAND     double
#define   COST   double

#define   GAIN_FUNC   -30
#define   RELAT_GAIN_FUNC    -31
// Stream definition
#define    In           cin
#define    Out          cout
#define    Error        cout
// Constant Definition
#define   EXEC_OK       1
#define    YES          1
#define    NO           0
#define    PARTIC_LOOP 1  
#define    STREAM_COST_LOOP 3   /// used in main loop around stream
#define    MAX_STREAM_LOOP 4
#define    ASYMMETRY_LOOP 5
#define   HOMOGENEOUS_ONLY   -10 // YES, NO, HOMO., values
//                                  for FIXED_PROBLEM global variable


#define    NONE       -1
#define    INFINIT_int  2147483647    // the biggest int in C++ here
#define    INFINIT_double ((double) INFINIT_int * INFINIT_int)
#define    Minus_INFINIT_double  ((-1) * INFINIT_double)
#define    Minus_INFINIT_int  ((-1) * INFINIT_int)
#define   NO_EDGE     INFINIT_int 
#define   INFINIT_DISTANCE INFINIT_int   // distance and weight are same type

//#define    NO_EDGE      INFINIT_int
#define MAX_LINE          1000   // max length of char in line 
#define MAX_STRING        50

#define BL                 ' '
#define    NL  '\n'
#define    EOL_CHAR     '.' /// meaning end of node edge description
#define    EOfNodeDesc_CHAR  '.'
#define    my_EOFILE_CHAR  '*'
#define    REAL_EOL_CHAR     '\n'
#define COMMENT_CHAR          '/'
#define GREAT                 40
#define LESS                  41
#define EQUAL                 42
#define UNKNOWN             43 //Edges:
//-------------Topology Input file Parser ---------------

#define Pars_EOF            -1
#define Pars_TotNODES       -2
#define Pars_TotEDGES       -3
#define Pars_NODEINFO       -4
#define Pars_EDGEINFO       -5
#define Pars_NODESETUP      -6
#define Pars_COMMENT        -7
#define Pars_TotMSGS        -8
#define Pars_OK              10
#define Pars_ERROR          -10
#define Pars_LONGLINE       -11
#define Pars_EOL            -12
#define Pars_EOfNodeDescr   -13
// ----------- used in findMST()--------------------------------
#define NONE                 -1
#define UNREACH_MST              49
#define NEIGH_MST                50
#define VISIT_MST                51
#define IN_TREE                  53
#define REACHED                  54
// ------------ Problem type ---------------------------

#define FIXED_TO_HIGH        100
#define NON_FIXED            101
#define FIXED_TO_LOW         102
/********Algorithm  codes ***********/
#define KMB 11 
#define RPF 12

#define MAX_STREAM_NPF     13   /// new 
#define OPT_STREAM_OPT_NPF 14  // new  optimal stream opimal participant
//#define OPT_STREAM_OPT     15   NON USED 25.4.97
//#define MAX_STREAM_OPT     16   NON USED 25.4.97
#define MIN_COST_NPF       19    // new
#define ONLINE_NPF         20
#define KMB_het 17 
#define KMB_low 18
//#define NPF_OPT_STREAM_OPT 20
// -------------------------------------------
#define error(str) Error << "ERROR: " << str << '\n'
//#define print(str) Out << str
//#define printN(str) Out << str << '\n'
#define debug(str)
#define debugL(str)
#define debug1(str)
#define debugL1(str)
#define debugN2(str)
#define debug2(str)
#define debug3(str) 
#define debugN3(str)
#define debug4(str) Out  << str 
#define debugN4(str) Out  << str << '\n'
#define debugP(str)

#define min(a,b)        ((a < b) ? a : b)
#define max(a,b)        ((a > b) ? a : b)
///#define infinitDistance(dist) ( (dist == INFINIT_DISTANCE) ? YES : NO)

// -------------------------------------------
//  NMsgs : Bullshit parameter left for compatibility with topology program

// Predeclaration of classes
class Edge;
class GraphClass;
///  GLOBAL VARIABLES
#ifdef MAIN
#define extern
#endif

// BOOL PROBLEM ; 
extern  ifstream InitFile;
extern double MAX_ASYMMETRY; // Max asymmetry of the graph
extern double A_COST  ;
extern double STREAM_RATIO;  // ratio of consecutive streams
extern double A_HAPCOST_PATH;
extern double B_HAPCOST_PATH;
extern double A_HAPCOST_STREAM;
extern double B_HAPCOST_STREAM;
extern BOOL HAP_COST_FUNC;
extern double A_HAPVAL;
extern double B_HAPVAL;
extern double C_HAPVAL;
extern STREAM  MAXSTREAM;    // maximum stream index 0,...,MAXSTREAM
extern double A_HAPCOST_TREE;
extern double B_HAPCOST_TREE;
extern BOOL   LOOP_TYPE; // choose loop:
//                      0=noLoop, 1=loop Partic, 3=loop strem cost 
 // Variables for looping around paramters
extern BOOL   FIXED_PROBLEM; // YES -> Nodes demand  max prefered stream
//                             HOMOGENEOUS_ONLY -> do not run all algos
extern double LOOP_STEP;
extern double LOOP_START;
extern double LOOP_END;

extern int SESSION_SEED;
//extern INDEX NoPart; // number of participants of a session
extern INDEX NoNodes; // number of nodes in original graph
extern Edge  **Matrix; // adjacency matrix of the orig. graph
extern GraphClass* GraphInfoPtr; // shortest path 


 // global external variable
 // extern Global_var

#ifdef MAIN
#undef extern
#endif


//--------------- predeclaration of classes ----------------

class Node;
class Edge ;
class Session;
class PathClass;
class GraphClass;
class AlgoStatusClass;
class HapCostInfoClass;

// ----------------- function predeclaration

// ------------------- io.cc -------------------
double readNL(ifstream &in);
void printArray(int *A, INDEX N, char *str, WEIGHT *sum);
void printMat(Edge **M, int Size);

// ------------------- multi.c    that has the main()
//

double chooseDouble(double a, double b);
BOOL toss() ;

INDEX chooseInt(INDEX aInt, INDEX bInt);
void initializeLine();
//int adjacent(INDEX n1, INDEX n2);
int adjacentMat(Edge **Mat, INDEX n1, INDEX n2);
int compareWeight(WEIGHT w1, WEIGHT w2);
void deleteArr(int *Ar, INDEX s);

//void createSessionNoAlloc(BOOL **Partic, INDEX N, PROB partThresh, INDEX *root);
void completeSubgraph(Edge **graph, INDEX N, Session *sessionPtr, 
			GraphClass *graphInfo, Edge **scdG);
Edge *  edgeMat(Edge **Mat, INDEX n1, INDEX n2);
BOOL spansAllDestinations(Session *sessPtr, INDEX *Father, INDEX root);
BOOL  minusInfinitCost(COST cost);
BOOL calculateTreeCost(GraphClass *graph, Session* sessPtr,
       INDEX *Father, STREAM *ExStream,HapCostInfoClass *hapCostPtr  );
void createEdge(Edge **Mat, INDEX n1, INDEX n2, WEIGHT w, double asym);
// -------------- npf.cc ---------------- 
double costEdgeStream(Edge *edge, STREAM s);
int findMST(Edge **Mat, INDEX N, INDEX root, INDEX *Father, WEIGHT *Label);
int findST_random(Edge **Mat, INDEX N, INDEX root, INDEX *Father, WEIGHT *Label);
int findDJK(Edge **Mat, INDEX N, INDEX root, INDEX *Father, WEIGHT *Label);
HAP findMSTAlgo(Edge **Mat, INDEX N, Session *sessionPtr,
		INDEX *Father, WEIGHT *Label, BOOL algo);
int randIntInAB(int a, int b);
INDEX randomPick(INDEX N, int *Status);
INDEX maxStreamNeigh(INDEX N, int *Stat, WEIGHT *Dist, STREAM *Stream);
void copyArr(INDEX *A, INDEX *B, INDEX N);  /* copy A to B */
double costBand(BAND u);
COST StreamBand(STREAM s);
double hapCostTree(HAP hap, COST cost);
//double hapVal(STREAM s);
void copyArr(INDEX *A, INDEX *B, INDEX N);
HAP performNPF(AlgoStatusClass *Algo, Session *sessionPtr,
		 BOOL algo, HapCostInfoClass *hapCost);
COST NPFcostUpdateStreamIncrease(AlgoStatusClass *Algo,Session *sessionPtr,
				 INDEX node, STREAM stream, BOOL update);
void NPFstreamIncreaseJoinInfoUpdate(AlgoStatusClass *Algo, Session *sessPtr,
				     INDEX newNode); 
void    printHops(char * tag, INDEX desti, INDEX toNode, INDEX hops, \
		  INDEX group,  INDEX nNodes, COST pathCost);
void calcPathLengths( char *nametag, GraphClass *graphInfo, Session *sess, \
		      INDEX *Fath,  INDEX *ExSrteam, INDEX *Tree);
// -------------- dijkstra.cc ---------------- 
Edge *edgeP(INDEX n1, INDEX n2);
// -------------- classes.cc ---------------- 
BOOL infinitDistance(WEIGHT dist);
BOOL  minusInfinitCost(COST cost);
BOOL homogeneous_only();

/// *.cc file with main must have #define MAIN
/// THis way only one definition (extern and real) appears)!



