#include "header.h"
#include "classes.h"
#include "session.h"
#include "algoClass.h"

// the trick thing that petros told me




void printArray(int *A, INDEX N, char *str, WEIGHT *sum) {
  // WHAT: print integer array with given string str for explanation
  //     question: can i do this for void pointer ???
  int i;

  *sum = 0;
  for (i=0; i<N; i++) {
    Out << "Index: " << i << BL << str << BL <<  A[i] << NL ;
    (*sum) += A[i];
  }
}
  
void newPrintMat(Edge **M, int Size) {
  // WHAT: print matrix M of size Size
  //       Prints in the format of the new simulator
  //      N:0 : .....	 (from node)
 //   :2, 135, 0, 516  (tonode, weight, del, capacity)

  int from, to;  
  int printedChar;
  int capacity;

  Out << NL;
  for(from=0; from<Size; from++) {
    Out << "N: " << from << ':';
    printedChar =0;
    for(to=0; to<Size; to++) {
      printedChar++;
      if (M[from][to].isNO_EDGE() == YES) {
	Out <<   "";
      } else {
		Out << " " << to << ", " ;
		Out <<" " << M[from][to].getWeight() <<" " ;
		// delay
        Out << (int) (drand48() * (30-1) + 1) << ", " ;
		if (M[from][to].getWeight() == 850)
			capacity = 2;
		else 
			capacity = 34;
        Out << (int) capacity  ;
        
		};
    };
    Out << NL;
  };
};
void printMat(Edge **M, int Size) {
  // WHAT: print matrix M of size Size

  int i, j;
  int printedChar;

  Out << NL;
  for(i=0; i<Size; i++) {
    Out << i << ':';
    printedChar =0;
    for(j=0; j<Size; j++) {
      printedChar++;
      if (M[i][j].isNO_EDGE() == YES) {
	Out << "   ";
      } else
	Out <<" " << M[i][j].getWeight() <<" " ;
    };
    Out << NL;
  };
};


BOOL isBlankChar(char c) {
  if ((c == ' ') || (c == '\t'))
    return YES;
  else
    return NO;
};

BOOL isNewLineChar(char c) {
  if (c == EOL_CHAR)
    return YES;
  else
    return NO;
} 

int MyIsdigit(char c) {
  if  ((c >= '0') && (c <= '9'))
    return YES;
  else
    return NO;
}
// ---------------- good old read file functions ---------

void readIn(int *tokPtr) {
  // WHAT: reads the following integer value of the file
  //       scans all the non digit values

  char numStr[MAX_STRING];
  int  index;
  char c;

  index = 0;
  do {
    In.get(c);
    //debug("readIn: until digit" << c);
  } while (MyIsdigit(c) == NO) ;
  // read next integer

 while ((MyIsdigit(c) == YES)&& (index < MAX_STRING)) {
    numStr[index] = c;
    index++ ;
    In.get( c);
    //debug("readIn: while digit" << c);
  }

  //debug("readlast char |" << c << "|");
  numStr[index] = '\0';

  // before atoi should i check sumStr end = \0
  *tokPtr =  atoi(numStr);
} ; // -------- readIn() ----------


BOOL getNext (int *nodeIdPtr, WEIGHT *auxPtr) {
  // WHAT: reads next "phrase" 
  // 1. ignore lines starting with "/"
  // 2. "N" means no of nodes -- only one number is read
  // 3. "M" means (auxiliary) -- one number is read
  // 4. "n" means node description: nodeid, no of adj. edges
  // 5. ":" follows the previous and refers to a descritpion of
  //     edge, other node ID and weight

  char c;
  int    nedges;
  WEIGHT weight;

  do {
    In.get( c);
    switch (c) {
    case COMMENT_CHAR:
      do{ In.get( c);
      } while (c != '\n'); //read comment to eofline
      break;
    case 'N':
      readIn( auxPtr);
      return Pars_TotNODES;
    case 'M':
      readIn( auxPtr);
      return Pars_TotMSGS;
    case 'n':       // begin info for node
      readIn(nodeIdPtr);
      readIn( auxPtr);
      return Pars_NODEINFO;
    case ':':      // read next pair (to-nodeId,  edge)
      readIn(nodeIdPtr);
      readIn( auxPtr);
      return Pars_EDGEINFO;
    case '\n':
      break;
    case ' ':
      break;
    case '.':
      break;
    case my_EOFILE_CHAR:
      return Pars_EOF;
    default :
      break;
    }; // switch end
  } while( 1 ) ;  // do end
};   // getNext();


int readNodesRoot(INDEX *nPtr, INDEX *rPtr) {
  // ATTENTION this is pure weight
  WEIGHT		aux;   // either weight or no of edges
  BOOL		status;
  INDEX		nodeId;

  Out << "ATTENTION!" ;
  Out << " M: .. in data file is the ROOT of the Solution"<< NL;
  if (getNext(&nodeId, &aux) != Pars_TotNODES)
    error("Reading Input file: couldn't find Total # of Nodes");
  *nPtr = (INDEX)  aux;

  Out << "nNodes: " << *nPtr << "\n"; 
  if (getNext(&nodeId, &aux) != Pars_TotMSGS)
    error("Reading Input file: couldn't find Total # of MSGs");
  *rPtr = (INDEX) aux;
  Out << "Root: " << *rPtr << "\n"; 
  return Pars_OK;
}


int readMatrix( GraphClass *graphInfo, INDEX nNodes,  INDEX *totEdgesPtr) {
  int		i,j;
  INDEX		edgeIndx, nedges;
  // ATTENTION this is pure weight
  WEIGHT		aux;   // either weight or no of edges
  BOOL		status;
  INDEX		node1, node2, nodeId;
  INDEX          totEdges;

  InitFile.open("InitFile.ini", ios::in);
  MAX_ASYMMETRY = readNL(InitFile);
   Out << " Assymetry MAX_ASYMMETRY: " << MAX_ASYMMETRY << NL ;
  // INIT TOPOLOGY   read file "data"
  totEdges =0;
  status = getNext(&nodeId, &aux);
  node1 = nodeId;   	
  for(i=0; i<nNodes; i++) {
    if (status != Pars_NODEINFO) 
      error(" Reading input file : no Node Info found");
    if (status == Pars_NODEINFO) {
      node1 = nodeId ;
      nedges = (INDEX) aux;
    }
    do {
      status = getNext(&nodeId, &aux);
      if (status == Pars_EDGEINFO) {
	graphInfo->createEdge(node1, nodeId, aux, MAX_ASYMMETRY);
	totEdges++;
      };
    } while (status == Pars_EDGEINFO);
  };

  *totEdgesPtr = totEdges;
  Out << "Data Read \n";
} // ---- readMatrix() ---------

// ---------------- end of good old read file functions  -----

void    printHops(char *tag, INDEX desti, INDEX toNode, INDEX hops, \
		  INDEX group, 	 INDEX nNodes, COST pathCost) {
  Out << tag ;
  Out << " new: " << desti;
  Out << " to: " << toNode ;
  Out << " Hops: " << hops;
  Out << " Grp: " << group;
  Out << " nN: " << nNodes;
  Out << " PthCost: " << (COST) pathCost;
  //  Out << " Asym: " <<      ;
  Out << NL ;

}


double readNL(ifstream &in)
{ // READ next number and discard the rest of the line
  // ATTENTION: File must be ready to read a number
 char c;
 double num;

  in >> num;
 do {
    in.get(c);
 }  while( c != '\n' );
 return num;
}

INDEX  readInitFile() {
  INDEX part;

// InitFile.ini is opened in readMatrix() to read the Assymetry factor
// ifstream InitFile("InitFile.ini", ios::in);

  //InitFile >> MAXSTREAM;
  MAXSTREAM = (int)  readNL(InitFile);
  MAXSTREAM-- ; // MAXSTREAM is the maximum stream index 0,...,L-1
   Out << " # Max Number of Streams in a session (0...L-1): ";
   Out << MAXSTREAM+1  <<NL;
   //InitFile >> part;
  part = (int)  readNL(InitFile);
   Out << " # Number of Participants: " << part << NL;
   //InitFile >> A_COST;
  A_COST = readNL(InitFile);
  Out << " # Cost function parameter: " << A_COST << NL;
  STREAM_RATIO = readNL(InitFile);
  Out << " # STREAM_RATIO parameter (= Higher/Lower - 1): " ;
    Out << STREAM_RATIO << NL;
  //InitFile >> A_HAPCOST_PATH;
  A_HAPCOST_PATH = readNL(InitFile);
   A_HAPCOST_STREAM = A_HAPCOST_PATH;
   Out << " # HapCost Path function parameter: a*hap " << A_HAPCOST_PATH << NL;
   //InitFile >> B_HAPCOST_PATH;
 B_HAPCOST_PATH = readNL(InitFile);
 B_HAPCOST_STREAM = B_HAPCOST_PATH;
   Out << " # HapCost Path function parameter: b*cost " << B_HAPCOST_PATH<< NL;
   //InitFile >> HAP_COST_FUNC;
  HAP_COST_FUNC = (int) readNL(InitFile);
   Out << " # Hapost PATH func. choice: Gain: "<<GAIN_FUNC;
   Out << " Relative Gain: "<< RELAT_GAIN_FUNC;
   Out << " choice: " << HAP_COST_FUNC << NL;

   Out << " #  B_HAPVAL * log((double)  A_HAPVAL * s + 1) + C_HAPVAL " << NL;
   //InitFile >> A_HAPVAL;
  A_HAPVAL = readNL(InitFile);
   Out << " # HapVal function parameter: A_HAPVAL: " << A_HAPVAL  ;
   //InitFile >> B_HAPVAL;
  B_HAPVAL =  readNL(InitFile);
   Out << " B_HAPVAL: " << B_HAPVAL ;
   //InitFile >> C_HAPVAL;
  C_HAPVAL =  readNL(InitFile);

   Out << " C_HAPVAL: " << C_HAPVAL << NL;
   //  InitFile >> A_HAPCOST_TREE;
  A_HAPCOST_TREE =  readNL(InitFile);
   Out << " # HapCost function parameter: a*hap " << A_HAPCOST_TREE << NL;
   //InitFile >> B_HAPCOST_TREE;
  B_HAPCOST_TREE =  readNL(InitFile);
   Out << " # HapCost function parameter: b*cost " << B_HAPCOST_TREE << NL;
   //InitFile >> LOOP_TYPE;
   FIXED_PROBLEM = (BOOL)  readNL(InitFile);
   Out << " # FIXED_PROBLEM (1=YES): "<< FIXED_PROBLEM << NL;
   //ifstream LoopFile("LoopFile.ini", ios::in);
  LOOP_TYPE = (int) readNL(InitFile);
  Out << " # Loop type: 0=noLoop,1=Part, 3=str.cost, 4=MaxStream, 5=Asymmetry? ";
   Out << LOOP_TYPE << NL;
   // 
  LOOP_START =  readNL(InitFile);
  Out << " # LOOP_START of sessions: " << LOOP_START << NL;
  //
  LOOP_END =  readNL(InitFile);
  Out << " # LOOP_END of sessions: " << LOOP_END << NL;
   // InitFile >> LOOP_STEP;
  LOOP_STEP =  readNL(InitFile);
  Out << " # LOOP_STEP  of sessions: " << LOOP_STEP << NL;
  //InitFile >> SESSION_SEED;
  //Out << " # Seed for randomization of session: " << SESSION_SEED << NL;
  return part;
}


