#define MAIN 
#include "header.h"
#include "classes.h"
#include "session.h"
#include "algoClass.h"
#include "io.h"

// the trick thing that petros told me




// -------------- GLOBAL Variables --------------
//Edge  **Matrix;   //// the main matrix with the topology
//INDEX    NoNodes; I made it global for all *.cc
//NodeClass *NodeInfo;
INDEX    AuxNodes = 1; // --- used in Mehlhorn KMB aglorithm
INDEX    NoEdges, NoMsgs;
INDEX    NoPartic;
//  NoMsgs : parameter left for compatibility with topology program

//**************** added by pertos *********************
// -------------- Local function prototypes -------------------

void deleteArr(int **Arr) {
  //WHAT: delete array of integers and make pointer NULL
  //      so that the pointer can be cheacked as NULL
  int i;
  
  //Out << "deleteArr: before deleting" << NL;
  delete [](*Arr);
  //Out << "deleteArr: after deleting" << NL;
  (*Arr) = (int *) NULL;
}


int compareWeight(WEIGHT w1, WEIGHT w2) {
  // WHAT: compare two weights and return GREAT,LESS, EQUAL
  /// USed in DIjkstra alhgorithm

  if (w1 > w2 ) return GREAT;
  if (w1 < w2 ) return LESS;
  return EQUAL;
};

BOOL adjacentMat(Edge **Mat,INDEX n1, INDEX n2) {
  // WHAT: return if two nodes are connected with an edge

  if ( Mat[n1][n2].isNO_EDGE() == YES)
    return NO;
  else
    return YES;
};




Edge*  edgeMat(Edge **Mat, INDEX n1, INDEX n2) {
  // WHAT: returns the pointer the edge n1,n2 of Mat
  return (&(Mat[n1][n2]));
}

double chooseDouble(double a, double b) {
  double tmp;
  
  tmp = drand48() * (b-a) + a;
  return tmp;
};

INDEX chooseInt(INDEX aInt, INDEX bInt) {
  // make sure that all integers have equal probability
 
  double choiceDouble;
  choiceDouble = chooseDouble((double) aInt, (double) bInt + .999);
 return (INDEX)  choiceDouble ;
};

BOOL chooseMaxProb(double thresh, double max) {
  // if  thresh is greater the more probable the YES
  // 0< thresh < max  and drand in [0,1] too
  double tmp, uni; 


  tmp = (double) thresh / max;
  uni = drand48();
  debug( " chooseMaxProb(): uni: " << uni << " thresh: " << thresh);
  if (tmp >= uni)
    return YES;
  else return NO;    
  
};

BOOL chooseProb(double thresh) {
  // if  thresh is greater the more probable the YES
  // 0< thresh < 1  
  return chooseMaxProb(thresh, 1.0);
 
}

BOOL toss() {
  // function that flips a coin yes/no
  return chooseProb(.5);
}


// ---------------- end of good old read file functions  -----

float uniformProb(int a, int b) {
  if (b > a)
  return (rand() * (float) (b - a) / (float) RAND_MAX);
  else return -1;
}


void calcPathLengths( char *nametag, GraphClass *graphInfo, Session *sess, \
		      INDEX *Fath,  STREAM *ExStream, INDEX *Tree){
  // nametag: the name of the algorithm that calls the function

  INDEX curNode;
  INDEX source; // root of session
  NODEID desti;
  INDEX count;   // counts destinations (source NOT a desti)
  INDEX partIdx;
  BOOL *curPart;
  INDEX noPart;
  INDEX hops;
  INDEX idx;
  Edge  *edge;
  COST pathCost;
  INDEX nNodes;

  nNodes = graphInfo->getNoNodes();
  curPart = new BOOL[nNodes];
  for(idx=0; idx < nNodes; idx++) {
    curPart[idx] = NO;
  }
 
 source  = sess->getSessRoot();
 noPart = sess->getNoPart();

 // for (no=0; no<nNodes ; no++)
 // if (Part[no] == YES)
 //   Tree[no] = Fath[no];
 // else
 //   Tree[no] = NONE;

 Fath[source] = source;
 curPart[source] = YES; 

 count = 0;  // number of destinations

 for (partIdx = 0; partIdx < noPart; partIdx++  ) {
   desti = sess->getJoinSequeNode(partIdx);
   hops = 0;
   pathCost = 0;

   if (desti == source) {
     curNode = source;
   } else {
     // Add new destination in the tree
     // Count new destination
     count++ ;   
        
     curNode = desti;
     //   Out << " calcPathLengths(): cost of path" ;
     while ( curPart[curNode] == NO) {
       curPart[curNode] = YES;

       
       edge = graphInfo->getEdge(Fath[curNode], curNode);
       //debugN4("calcPathLengths(): nodes: "<<Fath[curNode] <<" "<<curNode);
       //Out << " " << costEdgeStream(edge, ExStream[curNode]) ;
       pathCost += costEdgeStream(edge, ExStream[curNode]);
       hops++;

       curNode = Fath[curNode];
     }
     //Out << NL;
   }   // else
   if (desti == source)
     Out << " Source-" ;
   // count :  no of Part plus source before new node joins
   printHops(nametag, desti, curNode, hops, count, nNodes, pathCost);

 }   // for
};

//*********************************************
//	PROC: findRelTree()
//	DOES: Prunes  tree "Fath" that spans all nodes
//            and finds the sub tree that spans the Participants "Part"
//  ADDED:   3 5 96
//*********************************************
void findRelTree(INDEX N, INDEX *Fath, BOOL *Part, INDEX root,
 INDEX *Tree) {
  // Given N, Fath and Parti find and return the Tree nodes
  // Fath: array that has the tree information
  // Part: originally: the participants
  //       eventually: the multicast tree (sub-tree of Fath)
  // in Tree NONE if not in tree and the INDEX of their Father if they do
  // I.e. closure of father_of(Parti) on  space of Fath

 int i;
 BOOL STOP;

 
 // participants are in the tree
 for (i=0; i<N ; i++)
   if (Part[i] == YES)
     Tree[i] = Fath[i];
   else
     Tree[i] = NONE;

 // find closure
 do {
   STOP = YES;
   for (i=0; i<N ; i++) 
    if (Tree[i] != NONE && Tree[Fath[i]] == NONE) {
     Tree[Fath[i]] = Fath[Fath[i]];
     STOP = NO;
    };
 } while ( STOP == NO);
 
} // -- findRelTree

void doMultiMST(Edge** Mat, INDEX *Father_MST, WEIGHT *Label_MST,
		INDEX sessRoot,	int *SessPart, INDEX *MultiFath_MST,
		WEIGHT *totalMSTWeight,	WEIGHT *mtMSTCost) {
  int  i;
  WEIGHT junk;
  INDEX multiNodes;

   Out << " Find MST rooted at the root of the session" << NL;
   findMST(Matrix, NoNodes, sessRoot, Father_MST, Label_MST);
  (*totalMSTWeight) = 0;
   for(i=0; i<NoNodes; i++) {
     Out << i << ". Father: " << Father_MST[i];
     Out << " Label: " << Label_MST[i] ;
     Out << " Edg.Weight: " <<edgeMat(Mat,i, Father_MST[i])->getWeight();
     (*totalMSTWeight) += edgeMat(Mat,i, Father_MST[i])->getWeight();
     if (i == sessRoot )
       Out << " ROOT " ;
     else 
       if  ( i == Father_MST[i]) 
 	Out << " Second Root detected. \n     Disjoint graph. ";
     Out << NL ;
   }
   Out << " Total MST Weight: " << (*totalMSTWeight) << NL;
   // -------------------------------------------------------
   //  Perform Dijkstra algorithm
   // -------------------------------------------------------
   findRelTree(NoNodes, Father_MST, SessPart, sessRoot, MultiFath_MST);

   printArray(MultiFath_MST, NoNodes, "Father", &junk);
   (* mtMSTCost) = 0;
  multiNodes = 0;
   for (i=0; i<NoNodes; i++)
     if (MultiFath_MST[i] != NONE) {
       (* mtMSTCost) += edgeMat(Mat,i, MultiFath_MST[i])->getWeight();
       multiNodes++;
     }
   Out << " Total Number of MT nodes: "<< multiNodes;
   Out << " Total MST MT cost: " << (* mtMSTCost)  << NL;
 }

//*********************************************
//	PROC: calculateStreams()
//	DOES: Finds the stream that each node is traversed
//          given a tree "Father"
//          On the basis:
//          stream(father) >= stream(children)
//  ADDED:   2 5 96
//*********************************************
void calculateStreams(INDEX *Father, STREAM *Stream){
  INDEX node;
  BOOL stop;
  INDEX father;

  stop = NO;
  while (stop == NO) {
    stop = YES;
    for(node=0; node<NoNodes; node++) {
      father = Father[node];

      if ((father != NONE) && (Stream[father] < Stream[node])) {
	Stream[father] = Stream[node];
	stop = NO;
      };
    };
  };
};		      

//*********************************************
//	PROC: spansAllDestinations()
//	DOES: Checks if all the tree "Father" rooted from "root"
//          spans all destinations
// RETURNS: YES if all dest. are supported and NO otherwise
//  ADDED:   3 5 96
//*********************************************
BOOL spansAllDestinations(Session *sessPtr, INDEX *Father, INDEX root) {
  INDEX noNodes;
  INDEX node;
  INDEX father;
  BOOL success;
  INDEX pathNode;
  INDEX count; // aux count hops of path of a destination < NoNodes

  noNodes = sessPtr->getNoNodes();
  success = YES;
  for(node=0; node<NoNodes; node++) {
    if ( (sessPtr->isPartic(node))
	 && (node != root)) {

      pathNode = node;
      //debugN2(" dest: " << node);
      count = 0;
      do {
	//debug2(" n: " << pathNode << "  ");
	
	father = Father[pathNode];
	pathNode = father;
	if (father == NONE) 
	  success = NO;
	count++;
	if(count > NoNodes) {
	  Error << " spansAllDestinations(): ";
	  Error << " Attempt to walk a |path| > number_Nodes" << NL;
	  success = NO;
	};
      } while ((father != root) && (success == YES));
    };
    if (success == NO) break;
  };
  
};  


//*********************************************
//	PROC: selectStreamNode()
//	DOES: Select the opt stream for a "node"
//      RETURN: stream
//      ADDED:   3 5 97
//*********************************************
STREAM selectStreamNode(GraphClass *graph,Session *sessPtr, INDEX  node) {
  
 // ---  return maximum required stream ----
    return sessPtr->getNodeMaxReqStream(node);

};

STREAM selectOptStreamNode(GraphClass *graph,Session *sessPtr, INDEX  node) {
  // pathWeight not calculated not used
  
  INDEX inode, ifather; // used in looping along the path
  INDEX source;
  STREAM minStream, maxStream;
  PathClass *path;
  STREAM stream; // current stream
  HAP hap;  // hapinnes of node receiving "stream"
  HAP hapCost; // hapCost of examined stream
  HAP maxHapCost;  // maxHapCost among examined streams
  STREAM bestStream; // the stream for maxHapCost
  COST cost; // the cost of examined stream for the whole path
  // --- Return opt Unicast Stream -----
  minStream = sessPtr->getNodeMinReqStream(node);
  maxStream = sessPtr->getNodeMaxReqStream(node);
  source = sessPtr->getSessRoot();
  path = graph->getPathPtr(source, node);

  maxHapCost = Minus_INFINIT_double;
  bestStream = NONE;

  for(stream=minStream; stream <= maxStream; stream++) {
    // calculate cost-- ech time the edge (ifather, inode)
    path->initTraversal();
    ifather = path->getNextNodeId(); // the source
    inode = path->getNextNodeId();   // the next node
    cost = 0;
    while ( inode != NONE) {
      // We consider that the network is empty
      // I.e. we find opt stream in oblivion
      cost += costEdgeStream(graph->getEdge(ifather, inode), stream);
      // advance to next edge 
      ifather = inode;
      inode =  path->getNextNodeId();
    }
    hap = sessPtr->getNodeStreamHap(node, stream);
    hapCost = hapCostTree(hap,  cost);
    if ( maxHapCost < hapCost) {
      maxHapCost = hapCost;
      bestStream = stream;
    };

  }
  
  Out << " selectOptStreamNode(): node: "<<node;
  Out << " min: "<< minStream<<" max: " << maxStream;
  Out <<" OptStr: " << bestStream;
  Out << " MaxReqStr: " << sessPtr->getNodeMaxReqStream(node) << NL;
  return bestStream;

  // ---  return maximum required stream ----
  //  return sessPtr->getNodeMaxReqStream(node);
};

//*********************************************
//	PROC: calculateTreeCost()
//	DOES: Calculates the cost of tree "Father"
//            with stream ExStream"
//      RETURN: YES if everything is cool
//               and hapCostPtr the total Hap-Cost structure
//      ADDED:   3 5 96
//*********************************************
BOOL calculateTreeCost(GraphClass *graph, Session* sessPtr,
       INDEX *Father, STREAM *ExStream,HapCostInfoClass *hapCostPtr  ) {

  INDEX node; ///aux
  INDEX sessRoot;
  INDEX noNodes; 
  INDEX noPart;
  Edge **Mat;
  Edge *edge; // aux
  HAP totHap;
  HAP hap; // aux happines of examined participant
  COST totCost;
  BOOL checkCor;

  // --- Initialize ------
  noNodes = graph->getNoNodes();
  Mat = graph->getGraph();
  totCost = 0;
  totHap = 0;
  sessRoot = sessPtr->getSessRoot();
  noPart = sessPtr->getNoPart();
  /// --- Find the cost and happiness of the tree -------
  for(node = 0; node < noNodes; node++) {
    if (Father[node] != NONE) { 
      edge = edgeMat(Mat, Father[node], node);
      totCost += costEdgeStream(edge, ExStream[node]);
      //Out << "calculateTreeCost: costEdgeStream(): ";
      //Out <<" Edge: "<<  Father[node] <<" , " <<  node << " C= ";
      //Out << costEdgeStream(edge, ExStream[node]);
      //Out << " Str: " << ExStream[node] << NL;
      // -- Happiness for participants but not for root --
      if ((sessPtr->isPartic(node) == YES)
	  && (node != sessRoot)) {
	hap =  sessPtr->getNodeStreamHap(node, ExStream[node]);
	totHap += hap;
	debug3(" PartHap: " << hap ); 
	//// partipc - (root) for average level	 
      };
      if ( node == sessRoot)
	debug3(" ROOT ");
     debugN3("");   
   };
 
  };
  hapCostPtr->cost = totCost;
  hapCostPtr->hap = totHap;
  hapCostPtr->hapCost = hapCostTree(totHap, totCost);
  // hapCostPtr->print();
  //Out << NL;
  // Check if all destinations are spanned
  checkCor = spansAllDestinations(sessPtr, Father, sessRoot);
  if (checkCor == NO) 
    error(" NPF: Not all destinations were covered ");
  return checkCor;
} // end of calculateTreeCost()


Edge** reverseMat(Edge **graph, INDEX size) {
//---------------------------------------------
//	PROC: reverseMat
//      RETURN: prepare  matrix for execution
//              with reverse Shortest Paths
//      ADDED:   3 5 96
//---------------------------------------------
  Edge **rev;
  INDEX row, co;

  rev = new (Edge*)[size];
  for(row=0; row<size; row++) {
    rev[row] = new Edge[size];
    for(co=0; co<size; co++) {
      if (graph[co][row].isNO_EDGE() == YES)
	rev[row][co].makeNO_EDGE();
      else
	rev[row][co].setWeight(100);
    }
  }
  return rev;
}

// predeclaration of function ----
void performShortestPaths( GraphClass *graphInfo, Session *sessPtr,  \
          HapCostInfoClass *hapCostPtr, BOOL reverse, BOOL optStream) ;

//------------------------------------------
//	PROC: doShortestPaths()
//	DOES: call the Shortest Paths Algorithm 
//      RETURN: "hapCostPtr" information of result
//      ADDED:   3 5 96
//--------------------------------------------*
void doShortestPaths( GraphClass *graphInfo, Session *sessPtr,  \
                      HapCostInfoClass *hapCostPtr, BOOL optStream ) {
BOOL reverse;

reverse = NO;
performShortestPaths(graphInfo, sessPtr, hapCostPtr, reverse, optStream);
}

void doReverseShortestPaths( GraphClass *graphInfo, Session *sessPtr,  \
                      HapCostInfoClass *hapCostPtr, BOOL optStream ) {
BOOL reverse;

reverse = YES;
performShortestPaths(graphInfo, sessPtr, hapCostPtr, reverse, optStream);
}


void performShortestPaths( GraphClass *graphInfo, Session *sessPtr,  \
              HapCostInfoClass *hapCostPtr, BOOL reverse, BOOL optStream ) {
//--------------------------------------------*
//	DOES: Perform Shortest Paths Algorithm 
//      RETURN: "hapCostPtr" information of result
//    BOOL reverse: if YES execute reverse Path forwarding
//      ADDED:   3 5 96
//--------------------------------------------*
  INDEX sessRoot;
  INDEX noNodes;
  INDEX node;
  INDEX *Father;
  INDEX *MTree;
  BOOL *Partic;
  WEIGHT *Label;
  Edge **Mat;
  STREAM *Stream;
  Edge *edge;
  COST totCost;
  HAP totHap;
  int junkInt;
  BOOL checkCor;
  char nametag[20];  // name either SP or ReverseSP

  totHap = 0;
  totCost = 0;
  noNodes = graphInfo->getNoNodes();
  sessRoot = sessPtr->getSessRoot();
  if (reverse == YES) {
    Mat = reverseMat(graphInfo->getGraph(), noNodes);
    //printMat(Mat, noNodes);
    strcpy(nametag, "RSP ");
  } else {
      Mat = graphInfo->getGraph();
      strcpy(nametag, "SP ");
  }
  noNodes = graphInfo->getNoNodes();
  sessRoot = sessPtr->getSessRoot();
  Father = new INDEX[noNodes];
  MTree = new INDEX[noNodes];
  Label = new WEIGHT[noNodes];
  Stream = new STREAM[noNodes];
  Partic = sessPtr->getPartic();

  /// *** Make DJK calculate the cost or distance ??
  findDJK(Mat, noNodes, sessRoot, Father, Label);

  //printArray(Label, noNodes, " distance: ", &junkInt);
  /// Find which stream to offer to each node
   for(node=0; node<noNodes; node++)
    if (sessPtr->isPartic(node) == YES)
      {
      // --- FIND stream for each node ----
	if (optStream == YES) {
	// Offer unicast optimized stream to each destination
	  Stream[node] = selectOptStreamNode(graphInfo, sessPtr, node);
	} else {
	  // Offer Max Stream to each destination
	  Stream[node] = selectStreamNode(graphInfo, sessPtr, node);
	}
    } else 
      Stream[node] = NONE;
  /// --- Find the stream of each node ------
  findRelTree(noNodes, Father, Partic, sessRoot, MTree);
  calculateStreams(MTree, Stream);
  calculateTreeCost(graphInfo, sessPtr, MTree, Stream, hapCostPtr);
  calcPathLengths(nametag, graphInfo, sessPtr,  Father, Stream, MTree);
  checkCor = spansAllDestinations(sessPtr, MTree, sessRoot);
  if (checkCor == NO) 
    error(nametag << ": Not all destinations were covered ");

  //  if (reverse == YES) {
  //for (node = 0; node < noNodes ; node++)
  //   delete []Mat[node];
  // delete []Mat;
  //  printMat(Mat, noNodes);
  //}   selectOptStreamNode
  
  
}; // ---- 

void doNPF(GraphClass *graphInfo, Session *sessPtr,                                       HapCostInfoClass *hapCostPtr, int algoType ) {
  AlgoStatusClass * algoStatPtr;
  INDEX noNodes;
  
  noNodes = graphInfo->getNoNodes();
  algoStatPtr = new AlgoStatusClass(graphInfo);
  algoStatPtr->setType(algoType);
  performNPF(algoStatPtr, sessPtr, algoType, hapCostPtr);
      
  // ---  delete algostatus matrices but not graph !!!
  delete algoStatPtr;
};


void callNPFopt(GraphClass *graph, Session *sessPtr){
  HapCostInfoClass *NPFopt;
  INDEX noPart;

  noPart = sessPtr->getNoPart();
  NPFopt = new HapCostInfoClass;
  Out << " ------- PERFORM NPF opt --- P: " << noPart <<"----------" << NL;
  doNPF(GraphInfoPtr, sessPtr, NPFopt, OPT_STREAM_OPT_NPF);

  Out << NL;
  };

  //*********************************************
  //	PROC: heteroNPF()
  //	DOES: Perform some runs of NPF -- Print Results
  //  ADDED:   3 5 96
  //*********************************************
void heteroNPF(GraphClass *graph, Session *sessPtr) {
  INDEX maxStr;
  int type;
  int online;
  HapCostInfoClass *NPFlow, *NPFhi;
  HapCostInfoClass *NPFopt, *SPresults, *RSPresults, *optSPresults;
  HapCostInfoClass *maxStreamResults;
  HapCostInfoClass *minCostResults;
  HapCostInfoClass *onlineNPFopt;
  INDEX root, noPart;

  double a_cost_path ;
  double a_cost_stream ;

  NPFlow = new HapCostInfoClass;
  NPFhi = new HapCostInfoClass;
  NPFopt = new HapCostInfoClass;
  SPresults = new HapCostInfoClass;
  RSPresults = new HapCostInfoClass;
  maxStreamResults = new HapCostInfoClass;
  minCostResults = new HapCostInfoClass;
  onlineNPFopt =  new HapCostInfoClass;
  optSPresults = new HapCostInfoClass;
  root = sessPtr->getSessRoot();
  noPart = sessPtr->getNoPart();
  // Perform low stream NPF
  Out << " ------- PERFORM NPF low --- P: " << noPart <<"----------" << NL;
  type = sessPtr->getProblemType();
  sessPtr->setProblemType(FIXED_TO_LOW); 

    doNPF(graph, sessPtr, NPFlow, OPT_STREAM_OPT_NPF);
  sessPtr->setProblemType(type);
  // Perform opt stream NPF
  Out << NL;
  Out << " ------- PERFORM NPF hi --- P: " << noPart <<"----------" << NL;
  type = sessPtr->getProblemType();
  Out << " type: " << type << " fixed-to-high " << FIXED_TO_HIGH << NL;
  sessPtr->setProblemType(FIXED_TO_HIGH); 
  // Execute Algorithm only in the HETEROGENEOUS CASE
  if (homogeneous_only() == NO)
    doNPF(graph, sessPtr, NPFhi, OPT_STREAM_OPT_NPF);
  sessPtr->setProblemType(type);

  Out << NL;
  Out << " ------- PERFORM NPF opt --- P: " << noPart <<"----------" << NL;
  // Execute Algorithm only in the HETEROGENEOUS CASE
  if (homogeneous_only() == NO)
    doNPF(GraphInfoPtr, sessPtr, NPFopt, OPT_STREAM_OPT_NPF);

  Out << NL;
  Out << " ------- PERFORM SP hi --- P: " << noPart <<"----------" << NL;
  //  do SP hi -> do not optimize streams -> NO
  doShortestPaths(graph, sessPtr, SPresults, NO);
  Out << " SP: ";
  SPresults->print();

 Out << NL;
  Out << " ------- PERFORM SP opt --- P: " << noPart <<"----------" << NL;
  //  do SP opt ->  optimize streams -> YES
  doShortestPaths(graph, sessPtr, optSPresults, YES);
  Out << " SP: ";
  optSPresults->print();




  Out << " ------- PERFORM ReverseSP hi --- P: " << noPart <<"----------" << NL;
  // do not optimize stream -> NO
  doReverseShortestPaths(graph, sessPtr, RSPresults, NO);
  Out << " RSP: ";
  RSPresults->print();

  Out << NL;
  Out << " ------- PERFORM Opt Stream Max Stream PF  --- P: ";
  Out << noPart<<"----------" << NL;
    // Execute Algorithm only in the HETEROGENEOUS CASE
  if (homogeneous_only() == NO) {
     doNPF(graph, sessPtr, maxStreamResults, MAX_STREAM_NPF);
  } else {
     // make results point to the NPFlow results
     maxStreamResults = NPFlow;
  }
  Out << " MAX_STREAM_NPF: " ;
  maxStreamResults->print();

  Out << NL;
  Out << " ------- PERFORM Opt Stream Min Cost PF  --- P: ";
  Out << noPart<<"----------" << NL;
  
  a_cost_path = A_HAPCOST_PATH;
  A_HAPCOST_PATH = 0;
  // Execute Algorithm only in the HETEROGENEOUS CASE
  if (homogeneous_only() == NO)
    doNPF(graph, sessPtr, minCostResults, MIN_COST_NPF);
  A_HAPCOST_PATH = a_cost_path;
  Out << "OPT STR MIN COST NPF: " ;
  minCostResults->print();

  Out << NL;
  Out << " ------- PERFORM ONLINE NPF opt --- P: " << noPart <<"------" << NL;
  online = sessPtr->isOnline();
  sessPtr->setOnline(YES);
  doNPF(GraphInfoPtr, sessPtr, onlineNPFopt, OPT_STREAM_OPT_NPF);
  onlineNPFopt->print();
  sessPtr->setOnline(online);


  // sessPtr->setProblemType(type);
  //  Out << " ------- PERFORM NPF opt --- P: " << noPart <<"----------" << NL;
  
  Out << NL;
  Out << " RESULTS Part: " << sessPtr->getNoPart();
  Out << " SP_hi: " << SPresults->hapCost;
  Out  << " NPF_low: " << NPFlow->hapCost;
  Out << " NPF_hi: " << NPFhi->hapCost;
  Out << " NPF_opt: " << NPFopt->hapCost;
  Out << " NPF_MaxStream: " << maxStreamResults->hapCost;
  Out << " NPF_MinCost: " << minCostResults->hapCost;
  Out << " Str.Ratio: " << STREAM_RATIO;
  Out << " online_NPF_opt: " << onlineNPFopt->hapCost;
  Out << " NoStreams: " << MAXSTREAM;
  Out << " Asym: " << graph->getMaxAsymmetry() ; 
  Out << " RSP: " << RSPresults->hapCost;  
  Out << " SP_opt: " << optSPresults->hapCost;
  Out << NL;

  
  Out << NL;
  Out << " COST_RESULT Part: " << sessPtr->getNoPart();
  Out << " SP_hi: " << SPresults->cost;
  Out  << " NPF_low: " << NPFlow->cost;
  Out << " NPF_hi: " << NPFhi->cost;
  Out << " NPF_opt: " << NPFopt->cost;
  Out << " NPF_MaxStream: " << maxStreamResults->cost;
  Out << " NPF_MinCost: " << minCostResults->cost;
  Out << " Str.Ratio: " << STREAM_RATIO;
  Out << " online_NPF_opt: " << onlineNPFopt->cost;
  Out << " NoStreams: " << MAXSTREAM;
  Out << " Asym: " << graph->getMaxAsymmetry() ; 
  Out << " RSP: " << RSPresults->cost; 
  Out << " SP_opt: " << optSPresults->cost;
  Out << NL;

  
  Out << NL;
  Out << " HAP_RESULT Part: " << sessPtr->getNoPart();
  Out << " SP_hi: " << SPresults->hap;
  Out  << " NPF_low: " << NPFlow->hap;
  Out << " NPF_hi: " << NPFhi->hap;
  Out << " NPF_opt: " << NPFopt->hap;
  Out << " NPF_MaxStream: " << maxStreamResults->hap;
  Out << " NPF_MinCost: " << minCostResults->hap;
  Out << " Str.Ratio: " << STREAM_RATIO;
  Out << " online_NPF_opt: " << onlineNPFopt->hap;
  Out << " NoStreams: " << MAXSTREAM;
  Out << " Asym: " << graph->getMaxAsymmetry() ;  
  Out << " RSP: " << RSPresults->hap;
  Out << " SP_opt: " << optSPresults->hap;
  Out << NL;
};


//*********************************************
//	PROC: fixedHeteroNPF()
//	DOES:  FIXED problem to HIGH values,
// Perform some runs of NPF -- Print Results
//  ADDED:   3 5 96
//*********************************************
void fixedHeteroNPF(GraphClass *graph, Session *sessPtr) {
  int type;

  type = sessPtr->getProblemType();
  sessPtr->setProblemType(FIXED_TO_HIGH );
  heteroNPF(graph, sessPtr);
  sessPtr->setProblemType(type);
}

void runASession(GraphClass *GraphInfoPtr, INDEX noPart) {
    BOOL    *SessPart;
  INDEX  sessRoot;
  INDEX noNodes;
  int i;
  //  float start = 0.01, end = 2;
   Session *curSession;

   noNodes = GraphInfoPtr->getNoNodes();
      curSession = new Session(noNodes, noPart, MAXSTREAM);
      curSession->makeSessPart();
      sessRoot = curSession->getSessRoot();
      SessPart = curSession->getPartic();
      noPart = curSession->getNoPart();
      if (FIXED_PROBLEM == YES){
	curSession->setProblemType(FIXED_TO_HIGH );
	Out << " Problem: FIXED_TO_HIGH";
      }

      Out <<" Participants: " << noPart;
      Out << " Source: " << sessRoot << NL;
      Out << " No.Streams: " << MAXSTREAM+1 << NL ;
      

      curSession->makeStreamHap();
      curSession->print();
      heteroNPF(GraphInfoPtr, curSession);
      //fixedHeteroNPF(GraphInfoPtr, curSession);
      delete curSession;
}
void loopStreamRatio(GraphClass *GraphInfoPtr, INDEX noPart) {
    BOOL    *SessPart;
  INDEX  sessRoot;
  int i;
  //  float start = 0.01, end = 2;
   Session *curSession;

  for (STREAM_RATIO  = LOOP_START;
       STREAM_RATIO <= LOOP_END;
       STREAM_RATIO += LOOP_STEP) {
    runASession(GraphInfoPtr, noPart);
  }
}

void loopParticipants(GraphClass *GraphInfoPtr) {
    BOOL    *SessPart;
  INDEX  sessRoot;
  INDEX noPart;
  int i;
  //  float start = 0.01, end = 2;
   Session *curSession;

  for (noPart  = (INDEX) LOOP_START; noPart <=  (INDEX) LOOP_END;
       noPart += (INDEX) LOOP_STEP) {
      runASession(GraphInfoPtr, noPart);
  };
}

void loopMaxStream(GraphClass *GraphInfoPtr, INDEX noPart ) {
  // USES global MAXSTREAM
  BOOL    *SessPart;
  INDEX  sessRoot;
  int i;
  //  float start = 0.01, end = 2;
   Session *curSession;

  for (MAXSTREAM  = (STREAM) LOOP_START; MAXSTREAM <= (STREAM) LOOP_END;
       MAXSTREAM += (STREAM) LOOP_STEP) {
      runASession(GraphInfoPtr, noPart);
  };
}

void loopAsymmetry(GraphClass *GraphInfoPtr, INDEX noPart ){
    double  asy;

    for( asy =  LOOP_START; asy <= LOOP_END; asy += LOOP_STEP) {
      GraphInfoPtr->makeAsymmetry(asy);
      // Recalculate the all shortest Paths
      // since the weights of the graphs changed !!
      GraphInfoPtr->allShortestPaths();
      runASession(GraphInfoPtr, noPart);
    }
};

BOOL homogeneous_only() {
  if (FIXED_PROBLEM == HOMOGENEOUS_ONLY) 
    { return YES; }
  else
    return NO;
};

main(int argc, char *argv[]) {

  int i, j;
  BOOL status;
  INDEX  node1, node2;
  INDEX  noEdges;
  int edges1;  // edges of node1
  WEIGHT  weight, aux, mtMSTCost;
  TOKEN   *tokenPtr;
  int     tokenStatus;
  INDEX   *Father_MST; // father of node in MST
  WEIGHT  *Label_MST;   // Distances of nodes on MST
  INDEX   *MultiFath_MST;  // father in Multi Tree pruning MST
  INDEX   *MTFath_SP;    // fathers in MT after union of SPs
  INDEX   *Father_SP;     // Father in MT of Shortest Paths
  WEIGHT  *Label_SP;    // distance in MT of Shortest Paths

  WEIGHT  totalMSTWeight; // weight of pruned MST-> MT
  WEIGHT  totalSPWeight; // Weight of SP MT
  // --- session variables
  Session *curSession;
  BOOL    *SessPart;
  INDEX   noPart;
  INDEX   maxNoPart;
  INDEX  sessRoot;
  PROB    sessThresh = .3;    // ------ session participation --- //
  //STREAM  MaxStream = 2;
  INDEX   multiNodes = 0;
  BOOL    problem;
  
  //AlgoStatusClass *algoStatPtr; // structure that keeps track of algo exec.

    int junkInt, numEx ;
  int *junkPtr;
  //int MAX_NUM_EX = 100 ; // maximum number of experiments

  HapCostInfoClass *NPFresults;
  HapCostInfoClass *SPresults;

  NPFresults = new HapCostInfoClass;
  SPresults = new HapCostInfoClass;
  junkPtr = new int; // junk
  *junkPtr = 1; //junk
  

  Out << " Starting. " << NL;
 
  //  if ( argc >= 2)
  // MAX_NUM_EX = atoi(argv[1]) ;
  //cout << "Number of loops: " << MAX_NUM_EX << NL ;
  // initialize random generator drand48()
  //srand48(1500);

  if (argc >= 2) 
    SESSION_SEED = atoi(argv[1]);
 else
    SESSION_SEED = 0;
  Out << " # Seed for randomization of session: " << SESSION_SEED << NL;
  readNodesRoot(&NoNodes, &sessRoot);


  // -------- Initialize Adjacency Matrix ----------------

  //printMat(Matrix, NoNodes);
  // ----------- Initialize graph info structure ----
  GraphInfoPtr = new GraphClass(NoNodes);
 // --------- READ Matrix--------------------------
  readMatrix(GraphInfoPtr, NoNodes,  &noEdges);
  printMat(GraphInfoPtr->getGraph(), NoNodes);
 // Find all shortest paths and store it in GraphInfoPtr (global)
  // When we loop over the asymmetry then 
  // the shortest paths are recculated
  GraphInfoPtr->allShortestPaths();
  //allShortestPaths(Matrix, NoNodes, GraphInfoPtr);

  // ---- Read InitFile.ini for global values -------
  noPart = readInitFile();
  if (homogeneous_only() == YES)
    Out << " HOMOGENEOUS ONLY PROBLEM (from InitFile.ini)"<<NL;
  switch (LOOP_TYPE) {
   case NO: 
    Out << "## No loop  execution" << NL;
    runASession(GraphInfoPtr, noPart);
    break;
  case STREAM_COST_LOOP:
    loopStreamRatio(GraphInfoPtr, noPart);
    break;
  case PARTIC_LOOP:
    loopParticipants(GraphInfoPtr);
    break;
  case MAX_STREAM_LOOP:
    loopMaxStream(GraphInfoPtr,noPart);
    break;
  case ASYMMETRY_LOOP:
    Out << "## ASYMMETRY_LOOP " << NL;
    loopAsymmetry(GraphInfoPtr,noPart);
    break;
   default:
    Out << "No type loop LOOP_TYPE specified" << NL;
    break;
  }
}
// ------ end of  main ()
