// -*-C++-*-

class Session {
  BOOL online;  // participants arrive online
  STREAM *MaxStreamArr ;// array of max stream of dest.
  BOOL  *Partic;       // array of bollean for participants
  HAP **NodeStreamHap; // (N x StreamMax) matrix of hap values
  INDEX  sessRoot;     // the session of the root in G
  //    PROB  thresh;        // the probabil. of dense session
  STREAM Smax;         // maximum index of streams of session: Smax+1 levels
  STREAM maxReqStream;	// maximum  required stream			
  INDEX nodes;         // number of nodes of graph G
  INDEX noPart;        // number of participants
				
  INDEX *wholeToSubIndex; // array n(G) -> i (complete subgraph)
  INDEX  *subToWholeIndex; // array i(complete)->n(G)
  Edge  **EdgeCompl; // edges of complete graph G'		    
  int   problemType; // type of problem
public:
// ************* Headers of methods for class Session**********
//         Session(INDEX nonodes, PROB prob, STREAM s);
//    void makeSessPart() 
//    void makeStreamHap()
//
//    INDEX *getPartic()
//    INDEX getSessRoot()
//    INDEX getSubSessRoot() get index of root in subgraph
//    STREAM *getSessMaxStream()
//    INDEX *getWholeToSubIndex()
//    INDEX *getSubToWholeIndex()
//    void makeCompleteGraph(Edge **graph) 
//    Edge** getCompleteGraph()
//    STREAM *getMaxStreamArr()
//    INDEX *getNoPart()
//    STREAM getNodeMaxReqStream(INDEX n)
//
//    BOOL isPartic(node)
//    HAPPI nodeStreamHap(INDEX n, STREAM s, HAPPI hap)
//  *********** Headers of methods ***************************** //
  // ATTENTION : Here Dest in methods means the index of the complete graph
BOOL isPartic(INDEX node) { return Partic[node]; };
INDEX *getPartic(){ return Partic;};
INDEX getSessRoot() { return sessRoot;};
INDEX getSubSessRoot(){ return wholeToSubIndex[sessRoot]; };
//STREAM *getMaxStreams() { return nodeMaxStream;};
STREAM clipStreamValue(STREAM stream, STREAM maxStream) {
  // This functions clips "stream" value if
  // over the maxStream 
  // This way we can set MAXSTREAM to a value and reduce the
  // numbers of streams of a session
    if (stream > maxStream )
      return maxStream;
    else 
      return stream;
  };

void setOnline(BOOL stat){
    if (stat != YES && stat!=NO)
      error("Session::setOnline(): assigning value: " << stat <<NL );
    online = stat;
    Out << "Session::setOnline(): assigning value: " << stat <<NL;
  };

BOOL isOnline(){
    return online;
  };

STREAM getSessMaxStream() { return clipStreamValue(Smax, MAXSTREAM); };
STREAM getMaxReqStream() {
 return clipStreamValue(maxReqStream, MAXSTREAM); }; // Of session.

STREAM  getDestMaxReqStream(INDEX i) {
  return clipStreamValue(MaxStreamArr[i], MAXSTREAM); }; //Of dest.
STREAM getNodeMaxReqStream(INDEX node) {
    if (problemType == FIXED_TO_LOW)
    return getNodeMinReqStream(node);
  else
    return getDestMaxReqStream(nodeToPart(node));
    // old version
    //    return clipStreamValue(getDestMaxReqStream(nodeToPart(node)), MAXSTREAM) ;
      };
STREAM getNodeMinReqStream(INDEX node) {
  if (problemType == FIXED_TO_HIGH)
    return getNodeMaxReqStream( node);
  else
    return 0;  // all minStream = 0
 };
void setProblemType(int type) {    problemType = type;  };
int  getProblemType() { return problemType;};
INDEX *getWholeToSubIndex(){return wholeToSubIndex;};
INDEX nodeToPart(INDEX n){ return wholeToSubIndex[n]; };
INDEX partToNode(INDEX p){ return subToWholeIndex[p]; };
INDEX *getSubToWholeIndex(){return subToWholeIndex;};
INDEX getNoPart() { return noPart; };
INDEX getNoNodes() {return nodes; };
Edge** getCompleteGraph(){return EdgeCompl; };
  // before the following was getNodeSteramHap() changed  on 27/4/96
BOOL validPartIdx(INDEX idx);
NODEID  getJoinSequeNode(INDEX part);

HAP getPartStreamHap(INDEX i, STREAM s) {
    if ((i<0) || (i >= noPart) || (s < 0) || (s > Smax) ) {
        Error << " ERROR: participant or stream index  out of bounds";
	Error << " Session::getPartStreamHap(): node: " << i;
	Error << " stream : " << s << " noPart: " << noPart ;
	Error << " Smax: " << Smax << NL;
	return 0;
    };
    s = clipStreamValue(s, MAXSTREAM);
    return NodeStreamHap[i][s]; 
};

BOOL isNodeReqStream(INDEX node, STREAM stream) {
////  node not participant
  if ( stream <= getNodeMaxReqStream(node))
    return YES;
  else 
    return NO;//// ATTENTION: node not participant
  };
  /// needs testing double check 

HAP getNodeStreamHap(INDEX n, STREAM str) {
  INDEX part;
  part = nodeToPart(n);
   return  getPartStreamHap( part, str);
  };
HAP calcMaxTotalHap();

void setEdgeCompl(INDEX i, INDEX j, WEIGHT w){ EdgeCompl[i][j].setWeight(w);
};

/* predeclaration of function */
/* id Session::makeCompleteGraph(class Edge **); */
/*  this is a pointer to the session -- C++ */
Edge ** makeCompleteGraph(Edge **graph, GraphClass *graphInfo);

STREAM *getMaxStreamArr() { return MaxStreamArr; };
/* STREAM getNodeMaxReqStream(INDEX n) { return MaxStreamArr[n]; }; */

  // ----------- Coinstructor of Session ------------------
Session(INDEX nonodes, INDEX part, STREAM s);
       /*****************************************
	constructor of class Session
	nonodes = number of nodes,
	prob = probability - density of session, and
	s = max stream number
	*****************************************/
// ----------- Destructor of Session ------------------
~Session();
HAP hapVal(STREAM s) ;
void print();
void makeStreamHap();
     /*****************************************
       method of Session 
       assigns  streams ONLY to participants
       and happinnes values
       NodeStreamHap matrix has entrie only for participants !!!
       *****************************************/
void makeSessPart() ;
  //*****************************************
  // method of Session
  // selects the participants and the sess root
  //       alters  Session::Partic[] 
  //  creates Session:: wholeToSubIndex and subToWholeIndex
  ///      *****************************************
};  // class Session
